/*!
 * \file      CommsigniaLayerFactory.hh
 * \brief     Header file for ITS Commsignia protocol layer factory.
 * \author    ETSI STF525
 * \copyright ETSI Copyright Notification
 *            No part may be reproduced except as authorized by written permission.
 *            The copyright and the foregoing restriction extend to reproduction in all media.
 *            All rights reserved.
 * \version   0.1
 */
#pragma once

#include "LayerStackBuilder.hh"

#include "CommsigniaLayer.hh"

class CommsigniaLayerFactory: public LayerFactory {
  static CommsigniaLayerFactory _f;
public:
  CommsigniaLayerFactory() {
    // register factory
    loggers::get_instance().log(">>> CommsigniaLayerFactory::CommsigniaLayerFactory");
    LayerStackBuilder::RegisterLayerFactory("COMMSIGNIA", this);
  };

  inline virtual Layer * createLayer(const std::string& p_type, const std::string& p_param) {
    return new CommsigniaLayer(p_type, p_param);
  };
}; // End of class CommsigniaLayerFactory

